

!!! Listing 1

module financeInfo {
{
  struct StockId {
  string name;
  string bourseId;
  };

interface stockInfo {
  void getStockData(in StockId id, in string tag, out string value)
  raises (invalidId);
  };

exception invalidId { string errMsg; };

}

!!! Listing 2

<?xml version="1.0"?>

<methodCall>
  <methodName>getStockData</methodName>
  <params>
    <param>
      <value>
        <struct>
          <member>name</member>
            <value><string>IBM</string></value>
          <member>bourseId</member>
            <value><string>NYSE</string></value>
        </struct>
      </value>
    </param>
    <param>
      <value><string>lastPrice</string></value>
    </param>
  </params>
</methodCall>

!!! Listing 3

<!--   structs   -->
<!ELEMENT StockId (name, bourseId)>

<!--   simple types   -->
<!ELEMENT name (#PCDATA)>
<!ELEMENT bourseId (#PCDATA)>
<!ELEMENT tag (#PCDATA)>
<!ELEMENT value (#PCDATA)>
<!ELEMENT errInfo (#PCDATA)>

<!--  requests   -->
<!ELEMENT getStockDataRequest (StockId, tag)>

<!--  responses   -->
<!ELEMENT getStockDataResponse (value)>

<!--   exceptions   -->
<!ELEMENT getStockDataException (errInfo)>

<!-- interface definition for request -->
<!ELEMENT stockInfoRequest (getStockDataRequest)>

<!-- interface definition for response -->
<!ELEMENT stockInfoResponse (getStockDataResponse |
          getStockDataException)>

!!! Listing 4

<?xml version="1.0" ?>
<!DOCTYPE stock SYSTEM "financeInfo.dtd">

<stockInfoRequest>
  <getStockDataRequest>
    <StockId>
      <name>IBM</name>
      <bourseId>NYSE</bourseId>
    </StockId>
    <tag>lastPrice</tag>
  </getStockDataRequest>
</stockInfoRequest>

!!! Listing 5

<?xml version="1.0" ?>
<!DOCTYPE stock SYSTEM "financeInfo.dtd">

<stockInfoResponse>
  <getStockDataResponse>
    <value>182.75</value>
  </getStockDataResponse>
</stockInfoResponse>

!!! Listing 6

POST /cgi-bin/info?cmd=getStockData HTTP/1.0
Content-type: application/x-www-form-urlencoded
Content-length: 53

StockId-name=IBM&StockId-bourseId=NYSE&tag=lastPrice

!!! Listing 7

#!/usr/local/bin/bash
#
# $1: CGI command
# $2: Parameterlist
# $3: Host
# $4: Port
#
if [ $# -ne 4 ]; then
   echo "usage: `basename $0` CGI-cmd params host port" 1>&2
   exit 1
fi

# here has to follow a complete URL encoding
text=`echo "$2" | sed "s,/,%2F,g"`
len=${#text}

netcat $3 $4 << EOH
POST $1 HTTP/1.0
Content-type: application/x-www-form-urlencoded
Content-length: $len

$text
EOH

!!! Listing 8

post "/cgi-bin/info?cmd=getStockData"  
     "StockId-name=IBM&StockId-bourseId=NYSE&tag=lastPrice" 
     stockserver 
     80


!!! Listing 9
